<?php

namespace Diamond\Infrastructure\Models\MailingTemplate\Base;

use \Exception;
use \PDO;
use Diamond\Infrastructure\Models\Mailing\Mailing;
use Diamond\Infrastructure\Models\MailingMessage\MailingMessage;
use Diamond\Infrastructure\Models\MailingTemplate\MailingTemplate as ChildMailingTemplate;
use Diamond\Infrastructure\Models\MailingTemplate\MailingTemplateQuery as ChildMailingTemplateQuery;
use Diamond\Infrastructure\Models\MailingTemplate\Map\MailingTemplateTableMap;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\ModelCriteria;
use Propel\Runtime\ActiveQuery\ModelJoin;
use Propel\Runtime\Collection\Collection;
use Propel\Runtime\Collection\ObjectCollection;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\Exception\PropelException;

/**
 * Base class that represents a query for the '_mailing_template' table.
 *
 *
 *
 * @method     ChildMailingTemplateQuery orderById($order = Criteria::ASC) Order by the id column
 * @method     ChildMailingTemplateQuery orderByBody($order = Criteria::ASC) Order by the body column
 * @method     ChildMailingTemplateQuery orderBySubject($order = Criteria::ASC) Order by the subject column
 * @method     ChildMailingTemplateQuery orderByName($order = Criteria::ASC) Order by the name column
 * @method     ChildMailingTemplateQuery orderBybodyFile($order = Criteria::ASC) Order by the body_file column
 *
 * @method     ChildMailingTemplateQuery groupById() Group by the id column
 * @method     ChildMailingTemplateQuery groupByBody() Group by the body column
 * @method     ChildMailingTemplateQuery groupBySubject() Group by the subject column
 * @method     ChildMailingTemplateQuery groupByName() Group by the name column
 * @method     ChildMailingTemplateQuery groupBybodyFile() Group by the body_file column
 *
 * @method     ChildMailingTemplateQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method     ChildMailingTemplateQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method     ChildMailingTemplateQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method     ChildMailingTemplateQuery leftJoinWith($relation) Adds a LEFT JOIN clause and with to the query
 * @method     ChildMailingTemplateQuery rightJoinWith($relation) Adds a RIGHT JOIN clause and with to the query
 * @method     ChildMailingTemplateQuery innerJoinWith($relation) Adds a INNER JOIN clause and with to the query
 *
 * @method     ChildMailingTemplateQuery leftJoinMailingMessage($relationAlias = null) Adds a LEFT JOIN clause to the query using the MailingMessage relation
 * @method     ChildMailingTemplateQuery rightJoinMailingMessage($relationAlias = null) Adds a RIGHT JOIN clause to the query using the MailingMessage relation
 * @method     ChildMailingTemplateQuery innerJoinMailingMessage($relationAlias = null) Adds a INNER JOIN clause to the query using the MailingMessage relation
 *
 * @method     ChildMailingTemplateQuery joinWithMailingMessage($joinType = Criteria::INNER_JOIN) Adds a join clause and with to the query using the MailingMessage relation
 *
 * @method     ChildMailingTemplateQuery leftJoinWithMailingMessage() Adds a LEFT JOIN clause and with to the query using the MailingMessage relation
 * @method     ChildMailingTemplateQuery rightJoinWithMailingMessage() Adds a RIGHT JOIN clause and with to the query using the MailingMessage relation
 * @method     ChildMailingTemplateQuery innerJoinWithMailingMessage() Adds a INNER JOIN clause and with to the query using the MailingMessage relation
 *
 * @method     ChildMailingTemplateQuery leftJoinMailing($relationAlias = null) Adds a LEFT JOIN clause to the query using the Mailing relation
 * @method     ChildMailingTemplateQuery rightJoinMailing($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Mailing relation
 * @method     ChildMailingTemplateQuery innerJoinMailing($relationAlias = null) Adds a INNER JOIN clause to the query using the Mailing relation
 *
 * @method     ChildMailingTemplateQuery joinWithMailing($joinType = Criteria::INNER_JOIN) Adds a join clause and with to the query using the Mailing relation
 *
 * @method     ChildMailingTemplateQuery leftJoinWithMailing() Adds a LEFT JOIN clause and with to the query using the Mailing relation
 * @method     ChildMailingTemplateQuery rightJoinWithMailing() Adds a RIGHT JOIN clause and with to the query using the Mailing relation
 * @method     ChildMailingTemplateQuery innerJoinWithMailing() Adds a INNER JOIN clause and with to the query using the Mailing relation
 *
 * @method     \Diamond\Infrastructure\Models\MailingMessage\MailingMessageQuery|\Diamond\Infrastructure\Models\Mailing\MailingQuery endUse() Finalizes a secondary criteria and merges it with its primary Criteria
 *
 * @method     ChildMailingTemplate|null findOne(?ConnectionInterface $con = null) Return the first ChildMailingTemplate matching the query
 * @method     ChildMailingTemplate findOneOrCreate(?ConnectionInterface $con = null) Return the first ChildMailingTemplate matching the query, or a new ChildMailingTemplate object populated from the query conditions when no match is found
 *
 * @method     ChildMailingTemplate|null findOneById(int $id) Return the first ChildMailingTemplate filtered by the id column
 * @method     ChildMailingTemplate|null findOneByBody(string $body) Return the first ChildMailingTemplate filtered by the body column
 * @method     ChildMailingTemplate|null findOneBySubject(string $subject) Return the first ChildMailingTemplate filtered by the subject column
 * @method     ChildMailingTemplate|null findOneByName(string $name) Return the first ChildMailingTemplate filtered by the name column
 * @method     ChildMailingTemplate|null findOneBybodyFile(string $body_file) Return the first ChildMailingTemplate filtered by the body_file column *

 * @method     ChildMailingTemplate requirePk($key, ?ConnectionInterface $con = null) Return the ChildMailingTemplate by primary key and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildMailingTemplate requireOne(?ConnectionInterface $con = null) Return the first ChildMailingTemplate matching the query and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 *
 * @method     ChildMailingTemplate requireOneById(int $id) Return the first ChildMailingTemplate filtered by the id column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildMailingTemplate requireOneByBody(string $body) Return the first ChildMailingTemplate filtered by the body column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildMailingTemplate requireOneBySubject(string $subject) Return the first ChildMailingTemplate filtered by the subject column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildMailingTemplate requireOneByName(string $name) Return the first ChildMailingTemplate filtered by the name column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildMailingTemplate requireOneBybodyFile(string $body_file) Return the first ChildMailingTemplate filtered by the body_file column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 *
 * @method     ChildMailingTemplate[]|Collection find(?ConnectionInterface $con = null) Return ChildMailingTemplate objects based on current ModelCriteria
 * @psalm-method Collection&\Traversable<ChildMailingTemplate> find(?ConnectionInterface $con = null) Return ChildMailingTemplate objects based on current ModelCriteria
 * @method     ChildMailingTemplate[]|Collection findById(int $id) Return ChildMailingTemplate objects filtered by the id column
 * @psalm-method Collection&\Traversable<ChildMailingTemplate> findById(int $id) Return ChildMailingTemplate objects filtered by the id column
 * @method     ChildMailingTemplate[]|Collection findByBody(string $body) Return ChildMailingTemplate objects filtered by the body column
 * @psalm-method Collection&\Traversable<ChildMailingTemplate> findByBody(string $body) Return ChildMailingTemplate objects filtered by the body column
 * @method     ChildMailingTemplate[]|Collection findBySubject(string $subject) Return ChildMailingTemplate objects filtered by the subject column
 * @psalm-method Collection&\Traversable<ChildMailingTemplate> findBySubject(string $subject) Return ChildMailingTemplate objects filtered by the subject column
 * @method     ChildMailingTemplate[]|Collection findByName(string $name) Return ChildMailingTemplate objects filtered by the name column
 * @psalm-method Collection&\Traversable<ChildMailingTemplate> findByName(string $name) Return ChildMailingTemplate objects filtered by the name column
 * @method     ChildMailingTemplate[]|Collection findBybodyFile(string $body_file) Return ChildMailingTemplate objects filtered by the body_file column
 * @psalm-method Collection&\Traversable<ChildMailingTemplate> findBybodyFile(string $body_file) Return ChildMailingTemplate objects filtered by the body_file column
 * @method     ChildMailingTemplate[]|\Propel\Runtime\Util\PropelModelPager paginate($page = 1, $maxPerPage = 10, ?ConnectionInterface $con = null) Issue a SELECT query based on the current ModelCriteria and uses a page and a maximum number of results per page to compute an offset and a limit
 * @psalm-method \Propel\Runtime\Util\PropelModelPager&\Traversable<ChildMailingTemplate> paginate($page = 1, $maxPerPage = 10, ?ConnectionInterface $con = null) Issue a SELECT query based on the current ModelCriteria and uses a page and a maximum number of results per page to compute an offset and a limit
 *
 */
abstract class MailingTemplateQuery extends ModelCriteria
{
    protected $entityNotFoundExceptionClass = '\\Propel\\Runtime\\Exception\\EntityNotFoundException';

    /**
     * Initializes internal state of \Diamond\Infrastructure\Models\MailingTemplate\Base\MailingTemplateQuery object.
     *
     * @param string $dbName The database name
     * @param string $modelName The phpName of a model, e.g. 'Book'
     * @param string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = 'default', $modelName = '\\Diamond\\Infrastructure\\Models\\MailingTemplate\\MailingTemplate', $modelAlias = null)
    {
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new ChildMailingTemplateQuery object.
     *
     * @param string $modelAlias The alias of a model in the query
     * @param Criteria $criteria Optional Criteria to build the query from
     *
     * @return ChildMailingTemplateQuery
     */
    public static function create(?string $modelAlias = null, ?Criteria $criteria = null): Criteria
    {
        if ($criteria instanceof ChildMailingTemplateQuery) {
            return $criteria;
        }
        $query = new ChildMailingTemplateQuery();
        if (null !== $modelAlias) {
            $query->setModelAlias($modelAlias);
        }
        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param ConnectionInterface $con an optional connection object
     *
     * @return ChildMailingTemplate|array|mixed the result, formatted by the current formatter
     */
    public function findPk($key, ?ConnectionInterface $con = null)
    {
        if ($key === null) {
            return null;
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getReadConnection(MailingTemplateTableMap::DATABASE_NAME);
        }

        $this->basePreSelect($con);

        if (
            $this->formatter || $this->modelAlias || $this->with || $this->select
            || $this->selectColumns || $this->asColumns || $this->selectModifiers
            || $this->map || $this->having || $this->joins
        ) {
            return $this->findPkComplex($key, $con);
        }

        if ((null !== ($obj = MailingTemplateTableMap::getInstanceFromPool(null === $key || is_scalar($key) || is_callable([$key, '__toString']) ? (string) $key : $key)))) {
            // the object is already in the instance pool
            return $obj;
        }

        return $this->findPkSimple($key, $con);
    }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param mixed $key Primary key to use for the query
     * @param ConnectionInterface $con A connection object
     *
     * @throws \Propel\Runtime\Exception\PropelException
     *
     * @return ChildMailingTemplate A model object, or null if the key is not found
     */
    protected function findPkSimple($key, ConnectionInterface $con)
    {
        $sql = 'SELECT `id`, `body`, `subject`, `name`, `body_file` FROM `_mailing_template` WHERE `id` = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), 0, $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(\PDO::FETCH_NUM)) {
            /** @var ChildMailingTemplate $obj */
            $obj = new ChildMailingTemplate();
            $obj->hydrate($row);
            MailingTemplateTableMap::addInstanceToPool($obj, null === $key || is_scalar($key) || is_callable([$key, '__toString']) ? (string) $key : $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param mixed $key Primary key to use for the query
     * @param ConnectionInterface $con A connection object
     *
     * @return ChildMailingTemplate|array|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, ConnectionInterface $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $dataFetcher = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($dataFetcher);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param array $keys Primary keys to use for the query
     * @param ConnectionInterface $con an optional connection object
     *
     * @return Collection|array|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, ?ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getReadConnection($this->getDbName());
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $dataFetcher = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($dataFetcher);
    }

    /**
     * Filter the query by primary key
     *
     * @param mixed $key Primary key to use for the query
     *
     * @return $this The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        $this->addUsingAlias(MailingTemplateTableMap::COL_ID, $key, Criteria::EQUAL);

        return $this;
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param array|int $keys The list of primary key to use for the query
     *
     * @return $this The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        $this->addUsingAlias(MailingTemplateTableMap::COL_ID, $keys, Criteria::IN);

        return $this;
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id > 12
     * </code>
     *
     * @param mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param string|null $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this The current query, for fluid interface
     */
    public function filterById($id = null, ?string $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(MailingTemplateTableMap::COL_ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(MailingTemplateTableMap::COL_ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        $this->addUsingAlias(MailingTemplateTableMap::COL_ID, $id, $comparison);

        return $this;
    }

    /**
     * Filter the query on the body column
     *
     * Example usage:
     * <code>
     * $query->filterByBody('fooValue');   // WHERE body = 'fooValue'
     * $query->filterByBody('%fooValue%', Criteria::LIKE); // WHERE body LIKE '%fooValue%'
     * $query->filterByBody(['foo', 'bar']); // WHERE body IN ('foo', 'bar')
     * </code>
     *
     * @param string|string[] $body The value to use as filter.
     * @param string|null $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this The current query, for fluid interface
     */
    public function filterByBody($body = null, ?string $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($body)) {
                $comparison = Criteria::IN;
            }
        }

        $this->addUsingAlias(MailingTemplateTableMap::COL_BODY, $body, $comparison);

        return $this;
    }

    /**
     * Filter the query on the subject column
     *
     * Example usage:
     * <code>
     * $query->filterBySubject('fooValue');   // WHERE subject = 'fooValue'
     * $query->filterBySubject('%fooValue%', Criteria::LIKE); // WHERE subject LIKE '%fooValue%'
     * $query->filterBySubject(['foo', 'bar']); // WHERE subject IN ('foo', 'bar')
     * </code>
     *
     * @param string|string[] $subject The value to use as filter.
     * @param string|null $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this The current query, for fluid interface
     */
    public function filterBySubject($subject = null, ?string $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($subject)) {
                $comparison = Criteria::IN;
            }
        }

        $this->addUsingAlias(MailingTemplateTableMap::COL_SUBJECT, $subject, $comparison);

        return $this;
    }

    /**
     * Filter the query on the name column
     *
     * Example usage:
     * <code>
     * $query->filterByName('fooValue');   // WHERE name = 'fooValue'
     * $query->filterByName('%fooValue%', Criteria::LIKE); // WHERE name LIKE '%fooValue%'
     * $query->filterByName(['foo', 'bar']); // WHERE name IN ('foo', 'bar')
     * </code>
     *
     * @param string|string[] $name The value to use as filter.
     * @param string|null $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this The current query, for fluid interface
     */
    public function filterByName($name = null, ?string $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($name)) {
                $comparison = Criteria::IN;
            }
        }

        $this->addUsingAlias(MailingTemplateTableMap::COL_NAME, $name, $comparison);

        return $this;
    }

    /**
     * Filter the query on the body_file column
     *
     * Example usage:
     * <code>
     * $query->filterBybodyFile('fooValue');   // WHERE body_file = 'fooValue'
     * $query->filterBybodyFile('%fooValue%', Criteria::LIKE); // WHERE body_file LIKE '%fooValue%'
     * $query->filterBybodyFile(['foo', 'bar']); // WHERE body_file IN ('foo', 'bar')
     * </code>
     *
     * @param string|string[] $bodyFile The value to use as filter.
     * @param string|null $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this The current query, for fluid interface
     */
    public function filterBybodyFile($bodyFile = null, ?string $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($bodyFile)) {
                $comparison = Criteria::IN;
            }
        }

        $this->addUsingAlias(MailingTemplateTableMap::COL_BODY_FILE, $bodyFile, $comparison);

        return $this;
    }

    /**
     * Filter the query by a related \Diamond\Infrastructure\Models\MailingMessage\MailingMessage object
     *
     * @param \Diamond\Infrastructure\Models\MailingMessage\MailingMessage|ObjectCollection $mailingMessage the related object to use as filter
     * @param string|null $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this The current query, for fluid interface
     */
    public function filterByMailingMessage($mailingMessage, ?string $comparison = null)
    {
        if ($mailingMessage instanceof \Diamond\Infrastructure\Models\MailingMessage\MailingMessage) {
            $this
                ->addUsingAlias(MailingTemplateTableMap::COL_ID, $mailingMessage->getMatId(), $comparison);

            return $this;
        } elseif ($mailingMessage instanceof ObjectCollection) {
            $this
                ->useMailingMessageQuery()
                ->filterByPrimaryKeys($mailingMessage->getPrimaryKeys())
                ->endUse();

            return $this;
        } else {
            throw new PropelException('filterByMailingMessage() only accepts arguments of type \Diamond\Infrastructure\Models\MailingMessage\MailingMessage or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the MailingMessage relation
     *
     * @param string|null $relationAlias Optional alias for the relation
     * @param string|null $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return $this The current query, for fluid interface
     */
    public function joinMailingMessage(?string $relationAlias = null, ?string $joinType = Criteria::LEFT_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('MailingMessage');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'MailingMessage');
        }

        return $this;
    }

    /**
     * Use the MailingMessage relation MailingMessage object
     *
     * @see useQuery()
     *
     * @param string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return \Diamond\Infrastructure\Models\MailingMessage\MailingMessageQuery A secondary query class using the current class as primary query
     */
    public function useMailingMessageQuery($relationAlias = null, $joinType = Criteria::LEFT_JOIN)
    {
        return $this
            ->joinMailingMessage($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'MailingMessage', '\Diamond\Infrastructure\Models\MailingMessage\MailingMessageQuery');
    }

    /**
     * Use the MailingMessage relation MailingMessage object
     *
     * @param callable(\Diamond\Infrastructure\Models\MailingMessage\MailingMessageQuery):\Diamond\Infrastructure\Models\MailingMessage\MailingMessageQuery $callable A function working on the related query
     *
     * @param string|null $relationAlias optional alias for the relation
     *
     * @param string|null $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return $this
     */
    public function withMailingMessageQuery(
        callable $callable,
        string $relationAlias = null,
        ?string $joinType = Criteria::LEFT_JOIN
    ) {
        $relatedQuery = $this->useMailingMessageQuery(
            $relationAlias,
            $joinType
        );
        $callable($relatedQuery);
        $relatedQuery->endUse();

        return $this;
    }
    /**
     * Use the relation to MailingMessage table for an EXISTS query.
     *
     * @see \Propel\Runtime\ActiveQuery\ModelCriteria::useExistsQuery()
     *
     * @param string|null $queryClass Allows to use a custom query class for the exists query, like ExtendedBookQuery::class
     * @param string|null $modelAlias sets an alias for the nested query
     * @param string $typeOfExists Either ExistsCriterion::TYPE_EXISTS or ExistsCriterion::TYPE_NOT_EXISTS
     *
     * @return \Diamond\Infrastructure\Models\MailingMessage\MailingMessageQuery The inner query object of the EXISTS statement
     */
    public function useMailingMessageExistsQuery($modelAlias = null, $queryClass = null, $typeOfExists = 'EXISTS')
    {
        return $this->useExistsQuery('MailingMessage', $modelAlias, $queryClass, $typeOfExists);
    }

    /**
     * Use the relation to MailingMessage table for a NOT EXISTS query.
     *
     * @see useMailingMessageExistsQuery()
     *
     * @param string|null $modelAlias sets an alias for the nested query
     * @param string|null $queryClass Allows to use a custom query class for the exists query, like ExtendedBookQuery::class
     *
     * @return \Diamond\Infrastructure\Models\MailingMessage\MailingMessageQuery The inner query object of the NOT EXISTS statement
     */
    public function useMailingMessageNotExistsQuery($modelAlias = null, $queryClass = null)
    {
        return $this->useExistsQuery('MailingMessage', $modelAlias, $queryClass, 'NOT EXISTS');
    }
    /**
     * Filter the query by a related \Diamond\Infrastructure\Models\Mailing\Mailing object
     *
     * @param \Diamond\Infrastructure\Models\Mailing\Mailing|ObjectCollection $mailing the related object to use as filter
     * @param string|null $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this The current query, for fluid interface
     */
    public function filterByMailing($mailing, ?string $comparison = null)
    {
        if ($mailing instanceof \Diamond\Infrastructure\Models\Mailing\Mailing) {
            $this
                ->addUsingAlias(MailingTemplateTableMap::COL_ID, $mailing->getMatId(), $comparison);

            return $this;
        } elseif ($mailing instanceof ObjectCollection) {
            $this
                ->useMailingQuery()
                ->filterByPrimaryKeys($mailing->getPrimaryKeys())
                ->endUse();

            return $this;
        } else {
            throw new PropelException('filterByMailing() only accepts arguments of type \Diamond\Infrastructure\Models\Mailing\Mailing or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Mailing relation
     *
     * @param string|null $relationAlias Optional alias for the relation
     * @param string|null $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return $this The current query, for fluid interface
     */
    public function joinMailing(?string $relationAlias = null, ?string $joinType = Criteria::LEFT_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Mailing');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Mailing');
        }

        return $this;
    }

    /**
     * Use the Mailing relation Mailing object
     *
     * @see useQuery()
     *
     * @param string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return \Diamond\Infrastructure\Models\Mailing\MailingQuery A secondary query class using the current class as primary query
     */
    public function useMailingQuery($relationAlias = null, $joinType = Criteria::LEFT_JOIN)
    {
        return $this
            ->joinMailing($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Mailing', '\Diamond\Infrastructure\Models\Mailing\MailingQuery');
    }

    /**
     * Use the Mailing relation Mailing object
     *
     * @param callable(\Diamond\Infrastructure\Models\Mailing\MailingQuery):\Diamond\Infrastructure\Models\Mailing\MailingQuery $callable A function working on the related query
     *
     * @param string|null $relationAlias optional alias for the relation
     *
     * @param string|null $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return $this
     */
    public function withMailingQuery(
        callable $callable,
        string $relationAlias = null,
        ?string $joinType = Criteria::LEFT_JOIN
    ) {
        $relatedQuery = $this->useMailingQuery(
            $relationAlias,
            $joinType
        );
        $callable($relatedQuery);
        $relatedQuery->endUse();

        return $this;
    }
    /**
     * Use the relation to Mailing table for an EXISTS query.
     *
     * @see \Propel\Runtime\ActiveQuery\ModelCriteria::useExistsQuery()
     *
     * @param string|null $queryClass Allows to use a custom query class for the exists query, like ExtendedBookQuery::class
     * @param string|null $modelAlias sets an alias for the nested query
     * @param string $typeOfExists Either ExistsCriterion::TYPE_EXISTS or ExistsCriterion::TYPE_NOT_EXISTS
     *
     * @return \Diamond\Infrastructure\Models\Mailing\MailingQuery The inner query object of the EXISTS statement
     */
    public function useMailingExistsQuery($modelAlias = null, $queryClass = null, $typeOfExists = 'EXISTS')
    {
        return $this->useExistsQuery('Mailing', $modelAlias, $queryClass, $typeOfExists);
    }

    /**
     * Use the relation to Mailing table for a NOT EXISTS query.
     *
     * @see useMailingExistsQuery()
     *
     * @param string|null $modelAlias sets an alias for the nested query
     * @param string|null $queryClass Allows to use a custom query class for the exists query, like ExtendedBookQuery::class
     *
     * @return \Diamond\Infrastructure\Models\Mailing\MailingQuery The inner query object of the NOT EXISTS statement
     */
    public function useMailingNotExistsQuery($modelAlias = null, $queryClass = null)
    {
        return $this->useExistsQuery('Mailing', $modelAlias, $queryClass, 'NOT EXISTS');
    }
    /**
     * Exclude object from result
     *
     * @param ChildMailingTemplate $mailingTemplate Object to remove from the list of results
     *
     * @return $this The current query, for fluid interface
     */
    public function prune($mailingTemplate = null)
    {
        if ($mailingTemplate) {
            $this->addUsingAlias(MailingTemplateTableMap::COL_ID, $mailingTemplate->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

    /**
     * Deletes all rows from the _mailing_template table.
     *
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).
     */
    public function doDeleteAll(?ConnectionInterface $con = null): int
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(MailingTemplateTableMap::DATABASE_NAME);
        }

        // use transaction because $criteria could contain info
        // for more than one table or we could emulating ON DELETE CASCADE, etc.
        return $con->transaction(function () use ($con) {
            $affectedRows = 0; // initialize var to track total num of affected rows
            $affectedRows += parent::doDeleteAll($con);
            // Because this db requires some delete cascade/set null emulation, we have to
            // clear the cached instance *after* the emulation has happened (since
            // instances get re-added by the select statement contained therein).
            MailingTemplateTableMap::clearInstancePool();
            MailingTemplateTableMap::clearRelatedInstancePool();

            return $affectedRows;
        });
    }

    /**
     * Performs a DELETE on the database based on the current ModelCriteria
     *
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
     *                         if supported by native driver or if emulated using Propel.
     * @throws \Propel\Runtime\Exception\PropelException Any exceptions caught during processing will be
     *                         rethrown wrapped into a PropelException.
     */
    public function delete(?ConnectionInterface $con = null): int
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(MailingTemplateTableMap::DATABASE_NAME);
        }

        $criteria = $this;

        // Set the correct dbName
        $criteria->setDbName(MailingTemplateTableMap::DATABASE_NAME);

        // use transaction because $criteria could contain info
        // for more than one table or we could emulating ON DELETE CASCADE, etc.
        return $con->transaction(function () use ($con, $criteria) {
            $affectedRows = 0; // initialize var to track total num of affected rows

            MailingTemplateTableMap::removeInstanceFromPool($criteria);

            $affectedRows += ModelCriteria::delete($con);
            MailingTemplateTableMap::clearRelatedInstancePool();

            return $affectedRows;
        });
    }

}
